#pragma once

#include <windows.h>
#include <GL/glut.h>
#include <CEGUI.h>
#include <..\RendererModules\OpenGLGUIRenderer\openglrenderer.h>
#include "CEGUISystem.h"
#include "CEGUIWindow.h"
#include "CEGUIWindowManager.h"
#include "CEGUIImagesetManager.h"
#include "elements/CEGUIPushButton.h"
#include "elements/CEGUIListbox.h"
#include "elements/CEGUIListboxTextItem.h"
#include "elements/CEGUIMultiLineEditbox.h"
#include "elements/CEGUIScrollablePane.h"
#include "elements/CEGUIScrollbar.h"
#include "elements/CEGUIEditbox.h"
#include "UnicodeF.h"

using namespace CEGUI;

class CGUIManager
{
public:
    CGUIManager(void);
    ~CGUIManager(void);

    // Track the status of modifiers
    bool ctrl_held;
    bool alt_held;
    bool shift_held;
    int  d_lastFrameTime;

    CEGUI::OpenGLRenderer* renderer;
    CEGUI::System *system;
    CEGUI::Window *layout;

    void initGUI(CGUIManager *pointer);
    void renderGUI();
    bool OnListClick(const CEGUI::EventArgs &args);
    void setDebugText(const char* text);
    void subscribeEvent(const String& widget, const String& e, const Event::Subscriber& method);
    void checkEvent();

    GLfloat data[6];

    void fakeCtrlAltShift();
    // Map ASCII to Scan Codes
    int mapNormal(unsigned char c);
    // Map Special GLUT Keys to Scan Codes
    int mapSpecial(int c);

    void myKeyboardFunc(unsigned char key, int x, int y);
    void myKeyboardUpFunc(unsigned char key, int x, int y);

    void mySpecialFunc(int key, int x, int y);
    void mySpecialUpFunc(int key, int x, int y);

    void myMouseFunc(int button, int state, int x, int y);
    void myPassiveMotionFunc(int x, int y);
    void myMotionFunc(int x, int y);

};
